import java.util.*;
/**
 * The Demo class shows the importance of right implementation of the hashCode method. 
 * Try to uncomment different variants of the hashCode method in class Human.
 * 
 * @author xpopelk
 * @version 2013-12-03
 */
public class Demo
{
    public static void main(String [] args){
        Demo d = new Demo();
        long sum = 0;
        // The execution time can change, let's count the average from 10 runs.
        for (int i=0; i<10; i++){
            sum += d.createPopulation();
        }
        System.out.println("avg execution time "+(sum/10.0));
    }
    
    /**
     * Creates population of 10000 people and tries to find one certain person, 
     * comparison is one-to-each sequentially.
     * Measures and returns execution time of this process.
     * @return execution time
     */
    public long createPopulation(){
        String[] surnames = {"Krejci", "Peake", "Clinton", "Janku", "Morgan", "Bullock"}; 
        String[] forenames = {"Kaja", "Sasha", "Nikola", "Vlasta", "Rene", "Jarka"}; 
        Population p = new Population();
        long initTime = System.currentTimeMillis();
        //System.out.println("Population created ");
        for (int i = 0; i < 10000; i ++){
            String randomForename = (forenames[new Random().nextInt(forenames.length)]);
            String randomSurname = (surnames[new Random().nextInt(surnames.length)]);
            boolean randomSex = (new Random().nextInt(2)==1);
            //System.out.println(new Human(randomForename, randomSurname, randomSex));
            p.newBorn(new Human(randomForename, randomSurname, randomSex));
        }
        Human wanted = new Human("Vlasta", "Janku", true);
        for (Human h: p.getPeople()){
            if (h.equals(wanted)){
                //System.out.println(h+" found ");
            }
        }
        //System.out.println("Population searched at "+(System.currentTimeMillis()-initTime));
        return System.currentTimeMillis()-initTime;
    }
}
